---
title: Introduction
weight: 1
description: The 5-step storyflow of this Onboarding chapter
---

## Summary

This onboarding section is for you when are new to IPCEI-CIS subproject 'Edge Developer Framework (EDF)' and you want to know about 
* its context to 'Platform Engineering' 
* and why we think it's the stuff we need to care about in the EDF

## Storyline of our current project plan (2024)

1. We have the ['Edge Developer Framework'](./edgel-developer-framework/)
2. We think the solution for EDF is in relation to ['Platforming' (Digital Platforms)](./platforming/)
    1. The next evolution after DevOps
    2. Gartner predicts 80% of SWE companies to have platforms in 2026
    3. Platforms have a history since roundabout 2019
    4. CNCF has a working group which created capabilities and a maturity model
3. Platforms evolve - nowadys there are [Platform Orchestrators](./orchestrators/)
    1. Humanitec set up a Reference Architecture
    2. There is this 'Orchestrator' thing - declaratively describe, customize and change platforms!
4. Mapping our assumptions to the [CNOE solution](./cnoe/)
    1. CNOE is a hot candidate to help and fulfill our platform building
    2. CNOE aims to embrace change and customization!
5. [Showtime CNOE](./cnoe-showtime/)


## Please challenge this story!

Please do not think this story and the underlying assumptions are carved in stone!

1. Don't miss to further investigate and truely understand [**EDF specification needs**](./edgel-developer-framework/)
2. Don't miss to further investigate and truely understand [**Platform capabilities on top of DevOps**](./platforming/)
3. Don't miss to further investigate and truely understand [**Platform orchestration**](./orchestrators/)
3. Don't miss to further investigate and truely understand [**specific orchestratiing solutions like CNOE**](./cnoe/)

## Your role as 'Framework Engineer' in the Domain Architecture

Pls be aware of the the following domain and task structure of our mission: 

![](./conclusio/images/modern.png)



